/// <reference types="node" />
import { DataSource, DataSourceOptions } from 'typeorm';
import { AsyncLocalStorage } from 'async_hooks';
import { IsolationLevel, Propagation } from './typeorm-als.enums';
import { RouteInfo } from '@nestjs/common/interfaces/middleware/middleware-configuration.interface';
export interface TransactionalOptions {
    dataSource?: DataSource | DataSourceOptions | string;
    isolation?: IsolationLevel;
    propagation?: Propagation;
}
export interface TypeOrmAlsModuleOptions {
    exclude?: (string | RouteInfo)[];
}
export interface Connectable {
    dataSource: DataSource;
    storage: AsyncLocalStorage<Map<string, any>>;
}
