/// <reference types="node" />
import { DynamicModule, MiddlewareConsumer, OnModuleInit, NestModule } from '@nestjs/common';
import { AsyncLocalStorage } from 'async_hooks';
import { DiscoveryService } from '@nestjs/core';
import { TypeOrmAlsModuleOptions } from './typeorm-als.interfaces';
export declare class TypeOrmAlsModule implements OnModuleInit, NestModule {
    private readonly asyncStorage;
    private readonly options;
    private readonly discovery;
    static forRoot(options?: TypeOrmAlsModuleOptions): DynamicModule;
    private static createALS;
    constructor(asyncStorage: AsyncLocalStorage<Map<string, any>>, options: TypeOrmAlsModuleOptions, discovery: DiscoveryService);
    onModuleInit(): any;
    configure(consumer: MiddlewareConsumer): any;
}
