"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteEntityManager = exports.setEntityManager = exports.getEntityManager = exports.getQueryRunner = void 0;
const typeorm_als_constants_1 = require("./typeorm-als.constants");
const typeorm_1 = require("@nestjs/typeorm");
function getDatasourceKey(dataSource) {
    return (0, typeorm_1.getDataSourcePrefix)(dataSource) + typeorm_als_constants_1.ENTITY_MANAGER;
}
function getQueryRunner(store, dataSource) {
    const entityManager = getEntityManager(store, dataSource);
    if (entityManager) {
        const { queryRunner } = entityManager;
        if (queryRunner) {
            return queryRunner;
        }
    }
    return null;
}
exports.getQueryRunner = getQueryRunner;
function getEntityManager(store, dataSource) {
    const manager = store.get(getDatasourceKey(dataSource));
    if (!manager) {
        return null;
    }
    return manager;
}
exports.getEntityManager = getEntityManager;
function setEntityManager(store, dataSource, entityManager) {
    store.set(getDatasourceKey(dataSource), entityManager);
}
exports.setEntityManager = setEntityManager;
function deleteEntityManager(store, dataSource) {
    store.delete(getDatasourceKey(dataSource));
}
exports.deleteEntityManager = deleteEntityManager;
